unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ExtDlgs;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Bevel1: TBevel;
    Panel2: TPanel;
    Image1: TImage;
    Button1: TButton;
    Panel3: TPanel;
    Image2: TImage;
    Button2: TButton;
    Button3: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  if OpenPictureDialog1.Execute then
    Image1.Picture.LoadFromFile(OpenPictureDialog1.FileName);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if OpenPictureDialog1.Execute then
    Image2.Picture.LoadFromFile(OpenPictureDialog1.FileName);
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  Img1, Img2: TStream;
  I: integer;
  Dif: boolean;
  Ch1, Ch2: char;
begin
  // cria dois streams
  Img1 := TMemoryStream.Create;
  Img2 := TMemoryStream.Create;

  // copia o contedo dos bitmaps para os streams
  Image1.Picture.Bitmap.SaveToStream(Img1);
  Image2.Picture.Bitmap.SaveToStream(Img2);

  // verifica se so diferentes no tamanho e depois no contedo
  Dif := (Img1.Size <> Img2.Size);
  I := 0;
  Img1.Position := 0;
  Img2.Position := 0;
  while not Dif and (I < Img1.Size) do
    begin
      Img1.Read(Ch1, 1);
      Img2.Read(Ch2, 1);
      Dif := (Ch1 <> Ch2);
      Inc(I);
    end;

  // libera os strems da memria
  Img1.Free;
  Img2.Free;

  // exibe mensagens de acordo com o resultado
  if Dif then
    Showmessage('As imagens so diferentes.')
  else
    Showmessage('As imagens so iguais.');
end;

end.
